//  
#include <strstrea.h>
#include <fstream.h>
#include <stdlib.h>
#include <new.h>

#define TRUE          1
#define FALSE         0
#define true          1
#define false         0
#define BOOL          unsigned char
#define bool          unsigned char
#define PRESS_ENTER   " Enter  த..."

const char numbers[10] = {'0','1','2','3','4','5','6','7','8','9'};

int StrToInt(char *);
int StrLen(char *);
void StrCat(char *, char *);
int StrCmp(char *, char *);
void StrCpy(char *, char *);
void my_handler();
char Answer(char *);

class Record {
    char *pro;
    int  speed;
    int  memory;
    int  HDD;
    friend int Cmp1(Record *, Record *);
    friend int Cmp2(Record *, Record *);
    friend int Cmp3(Record *, Record *);
    friend int Cmp4(Record *, Record *);
  public:
    Record(char *s);
    ~Record() { delete pro; }
    bool Check();
    bool CheckEmpty() { return !pro[2]; }
    void GetData(char *s);
    bool Search(char *buf);
};

Record::Record(char *s)
{
  char *buf = new char[100];
  istrstream str(s);
  str.getline(buf, 100, '"');
  str.getline(buf, 100, '"');
  pro = new char[StrLen(buf) + 3];
  StrCpy(pro, "\"");
  StrCat(pro, buf);
  StrCat(pro, "\"");
  str >> speed;
  str >> memory;
  str >> HDD;
  delete buf;
}

bool Record::Check()
{
  if ((!pro[2]) || (speed < 1) || (memory < 1) || (HDD < 1))
    return TRUE;
  return FALSE;
}

void Record::GetData(char *s)
{
  ostrstream str(s, 100);
  str.setf(0x0002);
  str.width(20);
  str << pro;
  str.width(20);
  str << speed;
  str.width(20);
  str << memory;
  str << HDD;
  str << '\n';
  str << ends;
}

bool Record::Search(char *buf)
{
  char buf1[100];
  int n;

  istrstream str(buf);
  str.getline(buf1, 40, '\n');
  if (StrCmp(pro, buf1) && (buf1[1] != '*')) return FALSE;
  str >> buf1;
  istrstream(buf1) >> n;
  if ((speed != n) && (*buf1 != '*')) return FALSE;
  str >> buf1;
  istrstream(buf1) >> n;
  if ((memory != n) && (*buf1 != '*')) return FALSE;
  str >> buf1;
  istrstream(buf1) >> n;
  if ((HDD != n) && (*buf1 != '*')) return FALSE;

  return true;
}

struct List {
  Record *data;
  List *next, *prev;
};

ifstream& operator >>(ifstream&, List&);
ofstream& operator <<(ofstream&, List);

class DB {
    List *beg, *end, *l;
    int modified;
    void Title(char *);
    void ViewList(List *);
    void FieldNames(char *);
    void GetRec(char *);
    void SortProc(int, int (*)(Record *, Record *));
    void SortView();
    int SortMenu();
  public:
    void About();
    int Menu();
    void Load();
    void Save();
    void Clear(int);
    void View();
    void CheckModify();
    void Add();
    void Del();
    void Search();
    void Sort(int);
    DB() { beg = NULL; end = NULL; modified = FALSE; }
    ~DB() { Clear(0); }
} DataBase;

void DB::About()
{
  int i = 0;
  for (; i < 25; i++, cout << "\n");
  cout << "\n";
  cout << "******************************************************************************\n";
  cout << "*                       ᮢ ࠡ \" \"                        *\n";
  cout << "*                           㤥:  ࣥ                           *\n";
  cout << "*                           㯯:  3-2-41                                *\n";
  cout << "******************************************************************************\n";
  for (i = 0; i < 19; i++, cout << "\n");
  cout << "\t\t\t" << PRESS_ENTER;
  cin.get();
}

void DB::Title(char *s)
{
  int j = 0;

  cout << "|----------------------------------------------------------------------------|\n";
  cout << "|                         ᮢ ࠡ \" \"                      |\n";
  cout << "|----------------------------------------------------------------------------|\n";
  cout << "|";
  for (int i = 0; i < 39 - StrLen(s) / 2 - 7; i++, j++, cout << " ");
  cout << "****** ";
  cout << s;
  cout << " ******";
  for (int n = 0; n < 78 - j - 16 - StrLen(s); n++, cout << " ");
  cout << "|\n";
  cout << "|----------------------------------------------------------------------------|\n";
}

char Answer(char *message)
{
  char buf[128];
  cout << '\n';
  cout << message;
  cin.getline(buf, 128);
  cout << '\n';

  return buf[0];
}

int StrToInt(char *s)
{
  int n = 0, flag, mul = 1;
  char *t = s;

  while (*s++) {}
  s -= 2;

  while (s >= t)
  {
    flag = 0;
    for (int i = 0; i < 10; i++)
      if (*s == numbers[i])
      {
        flag |= 1;
        n += mul * i;
      }
    if (!flag) return -1;
    mul *= 10;
    s--;
  }

  return n;
}

int StrLen(char *s)
{
  int n = 0;
  while (*s++) n++;
  return n;
}

void StrCat(char *s1, char *s2)
{
  while (*s1++);
  s1--;
  while (*s2) *s1++ = *s2++;
  *s1 = *s2;
}

int StrCmp(char *s1, char *s2)
{
  int n = StrLen(s1), m = StrLen(s2);
  if (n != m)
  {
    if (n > m)
      return 1;
    else
      return -1;
  }
  for (int i = 0; i < n; i++)
    if (*s1++ != *s2++)
    {
      if (*--s1 > *--s2)
        return 1;
      else
        return -1;
    }
  return 0;
}

void StrCpy(char *s1, char *s2)
{
  while (*s2) *s1++ = *s2++;
  *s1 = *s2;
}

int DB::Menu()
{
  char *c = new char[128];

  Title(" ");
  cout << "                                                                              \n";
  cout << "                    |=======================================|                 \n";
  cout << "                    |        1.            |                 \n";
  cout << "                    |        2. ࠭         |                 \n";
  cout << "                    |        3. ᬮ ᯨ᮪          |                 \n";
  cout << "                    |        4.  ᯨ᮪             |                 \n";
  cout << "                    |        5.               |                 \n";
  cout << "                    |        6.                |                 \n";
  cout << "                    |        7. ஢  ⠭   |                 \n";
  cout << "                    |        8. ஢  뢠      |                 \n";
  cout << "                    |        9.                        |                 \n";
  cout << "                    |       10. 襭 ࠡ           |                 \n";
  cout << "                    |=======================================|                 \n";
  for (int i = 0; i < 6; i++)
    cout << '\n';
  cout << "\t\t\t\t 롮: ";
  cin.getline(c, 128);
  cout << '\n';
  int a = StrToInt(c);
  delete c;

  return a;
}

ifstream& operator >>(ifstream& f, List &l)
{
  char *buf = new char[100];
  f.getline(buf, 100, '\n');
  l.data = new Record(buf);
  delete buf;
  return f;
}

void DB::CheckModify()
{
  if (!modified) return;
  char c = Answer("   ᥭ . ࠭ (Y/N)? ");
  if ((c == 'y') || (c == 'Y'))
    Save();
}

void DB::Load()
{
  char *name = new char[128];
  int n = 0;

  Title("  ");
  cout << "\n  䠩: ";
  cin.getline(name, 128);
  ifstream in(name);

  if (!in)
  {
    cout << "  㪠 䠩.\n";
    Answer(PRESS_ENTER);
    delete name;
    return;
  }

  CheckModify();
  Clear(0);
  for (int i = 0; i < 2; i++)
    in.getline(name, 100, '\n');

  l = new List;
  in >> *l;

  while (in)
  {
    if (l -> data -> CheckEmpty())
    {
      l -> prev -> next = NULL;
      delete l -> data;
      delete l;
    }
    else
    {
      if (l -> data -> Check())
      {
        cout << "   ०  ᮤন ⨬ .\n";
        cout << "⠭ " << n << " ᥩ.\n";
        Answer(PRESS_ENTER);
        delete name;
        l -> prev -> next = NULL;
        delete l -> data;
        delete l;
        return;
      }
      l -> next = l -> prev = NULL;
      if (beg == NULL)
        beg = l;
      else
        end -> next = l;
      l -> prev = end;
      end = l;
      n++;
    }
    l = new List;
    in >> *l;
  }

  delete l -> data;
  delete l;

  in.close();
  cout << "⠭ " << n << " ᥩ.\n";
  Answer(" Enter த...");
  modified = FALSE;
  delete name;
}

ofstream& operator <<(ofstream& f, List l)
{
  char *buf = new char[100];
  l.data -> GetData(buf);
  f << buf;
  delete buf;
  return f;
}

void DB::FieldNames(char *s)
{
  ostrstream out(s, 200);
  out.setf(0x0002);
  out.width(5);
  out << "";
  out.width(20);
  out << " ";
  out.width(20);
  out << "⮢ ";
  out.width(20);
  out << "⨢ ";
  out << "";
  out << "\n-----------------------------------------------------------------------------\n";
  out << ends;
}

void DB::Save()
{
  l = beg;
  char *name = new char[200];
  int n = 1;

  Title("  ");

  if (beg == NULL)
  {
    cout << "  .\n";
    Answer(PRESS_ENTER);
    delete name;
    return;
  }

  cout << "\n  䠩: ";
  cin.getline(name, 128);
  ofstream out(name);

  if (!out)
  {
    cout << " ࠭  .\n";
    Answer(PRESS_ENTER);
    delete name;
    return;
  }

  FieldNames(name);
  out << name;

  while (l != NULL)
  {
    out.setf(0x0002);
    out.width(5);
    out << n++;
    out << *l;
    l = l -> next;
  }

  cout << "\n  ࠭.";
  Answer(" Enter த...");
  modified = FALSE;
  out.close();
}

void DB::ViewList(List *from)
{
  l = from;
  int n = 0, m = 1;
  char c, *buf = new char[200];

  FieldNames(buf);
  cout << buf;

  while (l != NULL)
  {
    cout.setf(0x0002);
    cout.width(5);
    cout << m;
    l -> data -> GetData(buf);
    cout << buf;
    n++;
    m++;
    if ((n > 18) && (l -> next != NULL))
    {
      n = 0;
      cout << "\n뢮 ᯨ᪠  祭";
      c = Answer("Enter - த, 㣠  - 襭 뢮.");
      if (c)
      {
        delete buf;
        return;
      }
      FieldNames(buf);
      cout << buf;
    }
    l = l -> next;
  }

  cout << "\n뢮 ᯨ᪠ 祭";
  Answer(PRESS_ENTER);
  delete buf;
}

void DB::View()
{
  Title("  ");

  if (beg == NULL)
  {
    cout << "  .\n";
    Answer(PRESS_ENTER);
    return;
  }

  cout << "\n";
  ViewList(beg);
}

void DB::Clear(int ask)
{
  List *l = beg;

  if (ask) Title("  ");

  if (beg == NULL)
  {
    if (ask)
    {
      cout << "  .\n";
      Answer(PRESS_ENTER);
    }
    return;
  }

  if (ask)
  {
    cout << "\n!    㤠!\n";
    char c = Answer(" ⢨⥫쭮     (Y/N)? ");
    if (c != 'y' && c != 'Y') return;
  }

  while (l != NULL)
  {
    beg = l -> next;
    delete l -> data;
    delete l;
    l = beg;
  }
  end = NULL;

  if (ask)
  {
    cout << "  饭.";
    Answer(PRESS_ENTER);
  }
}

void DB::GetRec(char *buf)
{
  char *buf1 = new char[128];

  ostrstream str(buf, 128);
  cout << " ⨯ : ";
  cin.getline(buf1, 128);
  str << '"' << buf1 << "\"\n";
  cout << " ⠪⮢ : ";
  cin.getline(buf1, 128);
  str << buf1 << '\n';
  cout << "  ⨢ : ";
  cin.getline(buf1, 128);
  str << buf1 << '\n';
  cout << "  ⪮ ᪠: ";
  cin.getline(buf1, 128);
  str << buf1 << ends;

  delete buf1;
}

void DB::Add()
{
  char *buf = new char[128], c;
  Title(" ");
  cout << '\n';

  do
  {
    GetRec(buf);
    l = new List;
    l -> data = new Record(buf);
    if (l -> data -> Check())
    {
      cout << "  ᪮쪮    ᮤঠ\n⨬ 祭.\n";
      delete l -> data;
      delete l;
    }
    else
    {
      l -> next = l -> prev = NULL;
      if (beg == NULL)
        beg = l;
      else
        end -> next = l;
      l -> prev = end;
      end = l;
    }
    c = Answer("    [Y/N]? ");
  } while (c == 'y' || c == 'Y');

  delete buf;
}

void my_handler()
{
  cout << "訡:  墠⠥ .\n";
  exit(1);
}

void DB::Del()
{
  char *buf = new char[128];
  List *t;
  int n = 0;

  Title(" ");
  if (beg == NULL)
  {
    cout << "  .\n";
    Answer(PRESS_ENTER);
    delete buf;
    return;
  }
  cout << " 㤠 ⮢  ᯮ짮  \"*\"\n";
  cout << '\n';
  GetRec(buf);
  cout << '\n';
  l = beg;

  while (l != NULL)
  {
    if (l -> data -> Search(buf))
    {
      t = l -> next;
      if (l == beg)
        beg = l -> next;
      else
        l -> prev -> next = l -> next;
      if (l == end)
        end = l -> prev;
      else
        l -> next -> prev = l -> prev;
      delete l -> data;
      delete l;
      l = t;
      n++;
    }
    else
      l = l -> next;
  }

  if (n)
    cout << " " << n << " ᥩ.";
  else
    cout << "  .";
  Answer(PRESS_ENTER);

  delete buf;
}

void DB::Search()
{
  char *buf = new char[128], *buf1 = new char[128], c;
  List *lbeg = NULL, *lend = NULL, *ll;
  int n = 0;

  Title(" ");
  if (beg == NULL)
  {
    cout << "  .\n";
    Answer(PRESS_ENTER);
    delete buf;
    return;
  }
  cout << " ᪠ ⮢  ᯮ짮  \"*\"\n";
  cout << '\n';
  GetRec(buf);
  cout << '\n';
  l = beg;

  while (l != NULL)
  {
    if (l -> data -> Search(buf))
    {
      ll = new List;
      ll -> next = ll -> prev = NULL;
      l -> data -> GetData(buf1);
      ll -> data = new Record(buf1);
      if (lbeg == NULL)
        lbeg = ll;
      else
        lend -> next = ll;
      ll -> prev = end;
      lend = ll;
      n++;
    }
    l = l -> next;
  }

  if (n)
  {
    cout << " " << n << " ᥩ.";
    c = Answer("   [Y/N]? ");
    if ((c == 'y') || (c == 'Y'))
      ViewList(lbeg);
  }
  else
  {
    cout << "  .";
    Answer(PRESS_ENTER);
  }

  ll = lbeg;

  while (ll != NULL)
  {
    lbeg = ll -> next;
    delete ll -> data;
    delete ll;
    ll = lbeg;
  }

  delete buf1;
  delete buf;
}

int Cmp1(Record *p, Record *q)
{
  int u = StrCmp(p -> pro, q -> pro);
  if (u) return u;
  u = p -> speed - q -> speed;
  if (u) return u;
  u = p -> memory - q -> memory;
  if (u) return u;
  u = p -> HDD - q -> HDD;
  if (u) return u;

  return 0;
}

int Cmp2(Record *p, Record *q)
{
  int u = u = p -> speed - q -> speed;
  if (u) return u;
  u = StrCmp(p -> pro, q -> pro);
  if (u) return u;
  u = p -> memory - q -> memory;
  if (u) return u;
  u = p -> HDD - q -> HDD;
  if (u) return u;

  return 0;
}

int Cmp3(Record *p, Record *q)
{
  int u = u = p -> memory - q -> memory;
  if (u) return u;
  u = StrCmp(p -> pro, q -> pro);
  if (u) return u;
  u = p -> speed - q -> speed;
  if (u) return u;
  u = p -> HDD - q -> HDD;
  if (u) return u;

  return 0;
}

int Cmp4(Record *p, Record *q)
{
  int u = u = p -> HDD - q -> HDD;
  if (u) return u;
  u = StrCmp(p -> pro, q -> pro);
  if (u) return u;
  u = p -> memory - q -> memory;
  if (u) return u;
  u = p -> speed - q -> speed;
  if (u) return u;

  return 0;
}

void DB::SortProc(int order, int (*cmp)(Record *, Record *))
{
  List *l1 = beg, *l2;
  Record *l3;

  while (l1 != NULL)
  {
    l2 = l1;
    while (l2 != NULL)
    {
      int res = cmp(l1 -> data, l2 -> data);
      if (order && (res < 0))
        res = 1;
      else
      if (!order && (res > 0))
        res = 1;
      else
        res = 0;
      if (res)
      {
        l3 = l1 -> data;
        l1 -> data = l2 -> data;
        l2 -> data = l3;
      }
      l2 = l2 -> next;
    }
    l1 = l1 -> next;
  }
}

int DB::SortMenu()
{
  char *c = new char[128];

  Title("");
  cout << "                                                                              \n";
  cout << "                    |=======================================|                 \n";
  cout << "                    |   1.  ⨯                |                 \n";
  cout << "                    |   2.  ⠪⮢               |                 \n";
  cout << "                    |   3.  ࠧ ⨢     |                 \n";
  cout << "                    |   4.   ⪮ ᪠         |                 \n";
  cout << "                    |                                       |                 \n";
  cout << "                    |   5.               |                 \n";
  cout << "                    |=======================================|                 \n";
  for (int i = 0; i < 10; i++)
    cout << '\n';
  cout << "\t\t\t\t 롮: ";
  cin.getline(c, 128);
  cout << '\n';
  int a = StrToInt(c);
  delete c;

  return a;
}

void DB::SortView()
{
  cout << "\n஢ 믮.";
  char c = Answer(" १ [Y/N]? ");
  if ((c == 'y') || (c == 'Y'))
    ViewList(beg);
}

void DB::Sort(int order)
{
  int choice;
  if (beg == NULL)
  {
    cout << "  .\n";
    Answer(PRESS_ENTER);
    return;
  }

  do
  {
    choice = SortMenu();

    switch (choice)
    {
      case 1: SortProc(order, Cmp1); SortView(); break;
      case 2: SortProc(order, Cmp2); SortView(); break;
      case 3: SortProc(order, Cmp3); SortView(); break;
      case 4: SortProc(order, Cmp4); SortView(); break;
      case 5: break;
    };
  } while (choice != 5);
}

void main()
{
  set_new_handler(my_handler);

  char c = '\0';
  int choice;

  DataBase.About();

  do
  {
    choice = DataBase.Menu();

    switch (choice)
    {
      case 1: DataBase.Load(); break;
      case 2: DataBase.Save(); break;
      case 3: DataBase.View(); break;
      case 4: DataBase.Clear(1); break;
      case 5: DataBase.Add(); break;
      case 6: DataBase.Del(); break;
      case 7: DataBase.Sort(0); break;
      case 8: DataBase.Sort(1); break;
      case 9: DataBase.Search(); break;
      case 10: c = Answer(" ⢨⥫쭮   (Y/N)? ");
    };
  } while (c != 'y' && c != 'Y');

  DataBase.CheckModify();
}
