#include <strstrea.h>
#include <fstream.h>
#include <stdlib.h>
#include <new.h>

#define TRUE          1
#define FALSE         0
#define true          1
#define false         0
#define BOOL          unsigned char
#define bool          unsigned char
#define PRESS_ENTER   " Enter  த..."

const char numbers[10] = {'0','1','2','3','4','5','6','7','8','9'};

int StrToInt(char *);
int StrLen(char *);
void StrCat(char *, char *);
int StrCmp(char *, char *);
void StrCpy(char *, char *);
void my_handler();
char Answer(char *);

class Record {
    char *pro;
    int  speed;
    int  memory;
    int  HDD;
  public:
    Record(char *s);
    ~Record() { delete pro; }
    bool Check();
    void GetData(char *s);
};

Record::Record(char *s)
{
  char *buf = new char[100];
  istrstream str(s);
  str.getline(buf, 100, '"');
  str.getline(buf, 100, '"');
  pro = new char[StrLen(buf) + 3];
  StrCpy(pro, "\"");
  StrCat(pro, buf);
  StrCat(pro, "\"");
  str >> speed;
  str >> memory;
  str >> HDD;
  delete buf;
}

bool Record::Check()
{
  if ((!*pro) || (speed < 1) || (memory < 1) || (HDD < 1))
    return TRUE;
  return FALSE;
}

void Record::GetData(char *s)
{
  ostrstream str(s, 100);
  str.setf(0x0002);
  str.width(20);
  str << pro;
  str.width(20);
  str << speed;
  str.width(20);
  str << memory;
  str << HDD;
  str << '\n';
  str << ends;
}

struct List {
  Record *data;
  List *next, *prev;
};

class DB {
    List *beg, *end, *l;
    int modified;
    void Title(char *s);
    ifstream& operator >>(ifstream&);
    ofstream& operator <<(ofstream&);
    void ViewList(List *);
  public:
    void About();
    int Menu();
    void Load();
    void Save();
    void Clear(int);
    void View();
    void CheckModify();
    DB() { beg = NULL; end = NULL; modify = FALSE; }
    ~DB() { Clear(0); }
} DataBase;

void DB::About()
{
  int i = 0;
  for (; i < 25; i++, cout << "\n");
  cout << "\n";
  cout << "******************************************************************************\n";
  cout << "*                       ᮢ ࠡ \" \"                        *\n";
  cout << "*                           㤥:  ࣥ                           *\n";
  cout << "*                           㯯:  3-2-41                                *\n";
  cout << "******************************************************************************\n";
  for (i = 0; i < 19; i++, cout << "\n");
  cout << "\t\t\t" << PRESS_ENTER;
  cin.get();
}

void DB::Title(char *s)
{
  int j = 0;

  cout << "|----------------------------------------------------------------------------|\n";
  cout << "|                         ᮢ ࠡ \" \"                      |\n";
  cout << "|----------------------------------------------------------------------------|\n";
  cout << "|";
  for (int i = 0; i < 39 - StrLen(s) / 2 - 7; i++, j++, cout << " ");
  cout << "****** ";
  cout << s;
  cout << " ******";
  for (int n = 0; n < 78 - j - 16 - StrLen(s); n++, cout << " ");
  cout << "|\n";
  cout << "|----------------------------------------------------------------------------|\n";
}

char DB::Answer(char *message)
{
  char *buf = new char[128];
  cout << '\n';
  cout << message;
  cin.getline(buf, 128);
  cout << '\n';

  return *buf;
}

int StrToInt(char *s)
{
  int n = 0, flag, mul = 1;
  char *t = s;

  while (*s++) {}
  s -= 2;

  while (s >= t)
  {
    flag = 0;
    for (int i = 0; i < 10; i++)
      if (*s == numbers[i])
      {
        flag |= 1;
        n += mul * i;
      }
    if (!flag) return -1;
    mul *= 10;
    s--;
  }

  return n;
}

int StrLen(char *s)
{
  int n = 0;
  while (*s++) n++;
  return n;
}

void StrCat(char *s1, char *s2)
{
  while (*s1++);
  s1--;
  while (*s2) *s1++ = *s2++;
  *s1 = *s2;
}

int StrCmp(char *s1, char *s2)
{
  int n = StrLen(s1), m = StrLen(s2);
  if (n != m)
  {
    if (n > m)
      return 1;
    else
      return -1;
  }
  for (int i = 0; i < n; i++)
    if (*s1++ != *s2++)
    {
      if (*--s1 > *--s2)
        return 1;
      else
        return -1;
    }
  return 0;
}

void StrCpy(char *s1, char *s2)
{
  while (*s2) *s1++ = *s2++;
  *s1 = *s2;
}

int DB::Menu()
{
  char *c = new char[128];

  Title(" ");
  cout << "                                                                              \n";
  cout << "                    |=======================================|                 \n";
  cout << "                    |        1.            |                 \n";
  cout << "                    |        2. ࠭         |                 \n";
  cout << "                    |        3. ᬮ ᯨ᮪          |                 \n";
  cout << "                    |        4.  ᯨ᮪             |                 \n";
  cout << "                    |        5.               |                 \n";
  cout << "                    |        6.                |                 \n";
  cout << "                    |        7. ஢...               |                 \n";
  cout << "                    |        8. ...                    |                 \n";
  cout << "                    |        9. 襭 ࠡ           |                 \n";
  cout << "                    |=======================================|                 \n";
  for (int i = 0; i < 7; i++)
    cout << '\n';
  cout << "\t\t\t\t 롮: ";
  cin.getline(c, 128);
  cout << '\n';
  int a = StrToInt(c);
  delete c;

  return a;
}

ifstream& operator >>(ifstream& f)
{
  char *buf = new char[100];
  f.getline(buf, 100, '\n');
  l -> data = new Record(buf);
  delete buf;
  return f;
}

void DB::CheckModify()
{
  if (!modified) return;
  char c = Answer("   ᥭ . ࠭ (Y/N)? ");
  if ((c == 'y') || (c == 'Y'))
    Save();
}

void DB::Load()
{
  char *name = new char[128];
  int n = 0;

  Title("  ");
  cout << "\n  䠩: ";
  cin.getline(name, 128);
  ifstream in(name);

  if (!in)
  {
    cout << "  㪠 䠩.\n";
    Answer(PRESS_ENTER);
    delete name;
    return;
  }

  CheckModify();
  Clear(0);
  for (int i = 0; i < 2; i++)
    in.getline(name, 100, '\n');

  l = new List;
  in >> *l;

  while (in)
  {
    l -> next = l -> prev = NULL;
    if (beg == NULL)
      beg = l;
    else
      end -> next = l;
    l -> prev = end;
    end = l;
    if (l -> data -> Check())
    {
      cout << "   ०.";
      Answer(PRESS_ENTER);
      delete name;
      return;
    }
    n++;
    l = new List;
    in >> *l;
  } while (in);

  delete l -> data;
  delete l;

  in.close();
  cout << "⠭ " << n << " ᥩ.\n";
  Answer(" Enter த...");
  modified = FALSE;
  delete name;
}

DB::ofstream& operator <<(ofstream& f)
{
  char *buf = new char[100];
  l -> data -> GetData(buf);
  f << buf;
  delete buf;
  return f;
}

void DB::FieldNames(char *s)
{
  ostrstream out(s, 200);
  out.setf(0x0002);
  out.width(5);
  out << "";
  out.width(20);
  out << " ";
  out.width(20);
  out << "⮢ ";
  out.width(20);
  out << "⨢ ";
  out << "";
  out << "\n-----------------------------------------------------------------------------\n";
  out << ends;
}

void DB::Save()
{
  l = beg;
  char *name = new char[200];
  int n = 1;

  Title("  ");

  if (beg == NULL)
  {
    cout << "  .\n";
    Answer(PRESS_ENTER);
    delete name;
    return;
  }

  cout << "\n  䠩: ";
  cin.getline(name, 128);
  ofstream out(name);

  if (!out)
  {
    cout << " ࠭  .\n";
    Answer(PRESS_ENTER);
    delete name;
    return;
  }

  FieldNames(name);
  out << name;

  while (l != NULL)
  {
    out.setf(0x0002);
    out.width(5);
    out << n++;
    out << *l;
    l = l -> next;
  }

  cout << "\n  ࠭.";
  Answer(" Enter த...");
  modified = FALSE;
  out.close();
}

void DB::ViewList(List *from)
{
  l = from;
  int n = 0, m = 1;
  char c, *buf = new char[200];

  FieldNames(buf);
  cout << buf;

  while (l != NULL)
  {
    cout.setf(0x0002);
    cout.width(5);
    cout << m;
    l -> data -> GetData(buf);
    cout << buf;
    n++;
    m++;
    if ((n > 18) && (l -> next != NULL))
    {
      n = 0;
      cout << "\n뢮 ᯨ᪠  祭";
      c = Answer("Enter - த, 㣠  - 襭 뢮.");
      if (c) return;
      FieldNames(buf);
      cout << buf;
    }
    l = l -> next;
  }

  cout << "\n뢮 ᯨ᪠ 祭";
  Answer(PRESS_ENTER);
  delete buf;
}

void DB::View()
{
  Title("  ");

  if (beg == NULL)
  {
    cout << "  .\n";
    Answer(PRESS_ENTER);
    return;
  }

  cout << "\n";
  ViewList(beg);
}

void DB::Clear(int ask)
{
  List *l = beg;

  if (ask) Title("  ");

  if (beg == NULL)
  {
    if (ask)
    {
      cout << "  .\n";
      Answer(PRESS_ENTER);
    }
    return;
  }

  if (ask)
  {
    cout << "\n!    㤠!\n";
    char c = Answer(" ⢨⥫쭮     (Y/N)? ");
    if (c != 'y' && c != 'Y') return;
  }

  while (l != NULL)
  {
    beg = l -> next;
    delete l -> data;
    delete l;
    l = beg;
  }
  end = NULL;

  if (ask)
  {
    cout << "  饭.";
    Answer(PRESS_ENTER);
  }
}

void my_handler()
{
  cout << "訡:  墠⠥ .\n";
  exit(1);
}

void main()
{
  set_new_handler(my_handler);

  char c = '\0';
  int choice;

  DataBase.About();

  do
  {
    choice = DataBase.Menu();

    switch (choice)
    {
      case 1: DataBase.Load(); break;
      case 2: DataBase.Save(); break;
      case 3: DataBase.View(); break;
      case 4: DataBase.Clear(1); break;
//      case 5: Add(); break;
//      case 6: Del(); break;
//      case 7: Sort(); break;
//      case 8: Search(); break;
      case 9: c = Answer(" ⢨⥫쭮   (Y/N)? ");
    };
  } while (c != 'y' && c != 'Y');

  DataBase.CheckModify();
}
